// This script is injected by Send To Maxel to handle link selection
function resolve(url, base_url) {
  var doc      = document
    , old_base = doc.getElementsByTagName('base')[0]
    , old_href = old_base && old_base.href
    , doc_head = doc.head || doc.getElementsByTagName('head')[0]
    , our_base = old_base || doc_head.appendChild(doc.createElement('base'))
    , resolver = doc.createElement('a')
    , resolved_url
    ;
  our_base.href = base_url;
  resolver.href = url;
  resolved_url  = resolver.href; // browser magic at work here

  if (old_base) old_base.href = old_href;
  else doc_head.removeChild(our_base);
  return resolved_url;
}

function getSelected() {
  try {
    var selection = window.getSelection();
    var range = selection.getRangeAt(0);

    var div = document.createElement('div');

    // If the user only selected the link
    if(range.commonAncestorContainer.parentElement.tagName == "A") {
      var node = range.startContainer.parentElement;
      range = document.createRange();
      range.selectNode(node);
    }

    div.appendChild(range.cloneContents());
    return div;
  } catch (e) {
    return null;
  }
}

// Get urls in selection
function getSelectedURLs() {
  var htmldiv = getSelected();
  if (htmldiv) {
    var anchors = htmldiv.getElementsByTagName('a');

    var urls = [];
    for(i = 0; i < anchors.length; i++) {
      url = {
        "href": resolve(anchors[i].getAttribute("href"), window.location.href),
        "title": anchors[i].innerHTML
      }

      urls.push(url);
    }

    return urls;
  }

  return [];
}

// Get url of element clicked on
function getTargetURL(evt) {
  if (evt.target && evt.target.href) {
    return [{"href": evt.target.href, "title": evt.target.innerHTML}];
  } else {
    return []
  }
}

// Search html for urls to make sure they are in our selection
function salientString(raw)
{
  var s = raw.replace(/ /g, '');
  s = s.replace(/\n/g, '');
  s = s.replace(/\t/g, '');
  return s;
}

// Parses the html and sends it to maxel
function extractURLsFromHTML(urls, selectedText)
{
  return urls;
  var haystack = salientString(selectedText);
  var filteredURLs = [];
  for(var i=0; i < urls.length; i++) {
    var url = urls[i];
    var needle = salientString(url.title);
    if(haystack.indexOf(needle) == -1) {
      // Skip this
    } else {
      filteredURLs.push(url);
    }
  }

  return filteredURLs;
}

// Uniquely merge a and b, skipping over duplicates
function uniqueMerge(a, b) {
  var both = a.concat(b);
  var lut = {};
  var ret = [];

  for (var i = 0; i < both.length; i++) {
    var href = both[i].href;
    if (!lut[href]) {
      // We have not seen this
      ret.push(both[i]);
      lut[href] = href;
    }
  }

  return ret;
}

// Inject info into the content
document.addEventListener('contextmenu', function (evt) {
  var fromTarget = getTargetURL(evt);
  var fromSelection = getSelectedURLs();

  var uniques = uniqueMerge(fromTarget, fromSelection);

  var asString = JSON.stringify(uniques);
  safari.extension.setContextMenuEventUserInfo(evt, {"selectedLinks": asString});
}, false);
